<!DOCTYPE html>
<html>

<head>
    <title>Lucky Dice Casino</title>
    <meta charset='utf-8'>
    <meta name='viewport' content='width=device-width, initial-scale=1'>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.16.0/umd/popper.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <!-- class CSS để dùng trong bài -->
    <style>
        .picture-cover {
            background-image: url("LuckyDiceImages/cover.jpg");
            min-height: 100px;
            margin: 5px;
        }
    </style>
</head>

<body>
    <div class="container-fluid  picture-cover">

    </div>
    <div class="container ">
        <div class="row ">
            <div class="col-5 bg-white  ">
                <div class="row  form-group">
                    <div class="col-12"> <!-- Tại dòng 2.1.1.1 thêm một div column rộng 12 đơn vị -->
                        <h4>Nhập thông tin của bạn</h4>
                    </div>
                </div>
                <div class="row   form-group">
                    <!-- tại mỗi dòng 2.1.1.2 thêm 2 div column có chiều rộng lần lượt là 4, 8 đơn vị -->
                    <div class="col-4  "> <!-- chiều rộng 4 đơn vị (col-4) -->
                        <label>Username</label>
                    </div>
                    <div class="col-8  "> <!-- chiều rộng 8 đơn vị (col-8) -->
                        <input id="inp-user-name" class="form-control" type="text">
                    </div>
                </div>
                <div class="row   form-group">
                    <!-- tại mỗi dòng 2.1.1.3 thêm 2 div column có chiều rộng lần lượt là 4, 8 đơn vị -->
                    <div class="col-4  "> <!-- chiều rộng 4 đơn vị (col-4) -->
                        <label>Firstname</label>
                    </div>
                    <div class="col-8  "> <!-- chiều rộng 8 đơn vị (col-8) -->
                        <input id="inp-first-name" class="form-control" type="text">
                    </div>
                </div>
                <div class="row   form-group">
                    <!-- tại mỗi dòng 2.1.1.4 thêm 2 div column có chiều rộng lần lượt là 4, 8 đơn vị -->
                    <div class="col-4  "> <!-- chiều rộng 4 đơn vị (col-4) -->
                        <label>Lastname</label>
                    </div>
                    <div class="col-8  "> <!-- chiều rộng 8 đơn vị (col-8) -->
                        <input id="inp-last-name" class="form-control" type="text">
                    </div>
                </div>
            </div>
            <div class="col-4  text-center">
                <!-- Tại cột 2.1.2 tạo 3 div class row, cột 2.1.2 có thuộc tính căn giữa -->
                <div class="row form-group">
                    <div class="col-12   "> <!-- trong mỗi row chứa 1 cột rộng 12 đơn vị -->
                        <input id="btn-dice" class="btn btn-success button-width w-75" value="Ném" type="button">
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-12   "> <!-- trong mỗi row chứa 1 cột rộng 12 đơn vị-->
                        <img id="img-dice" class="img-thumbnail" src="LuckyDiceImages/dice.png">
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-12   "> <!-- trong mỗi row chứa 1 cột rộng 12 đơn vị -->
                        <p id="p-notification-dice">Chúc mừng</p>
                    </div>
                </div>
            </div>
            <div class="col-3  text-center">
                <!-- Tại cột 2.1.3 tạo 2 div class row, cột 2.1.3 có thuộc tính căn giữa -->
                <div class="row form-group">
                    <div class="col-12   "> <!-- trong mỗi row chứa 1 cột rộng 12 đơn vị -->
                        <p>Voucher</p>
                        <p id="p-voucher-id">No ID</p>
                        <p id="p-voucher-percent">0%</p>
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-12   "> <!-- trong mỗi row chứa 1 cột rộng 12 đơn vị-->
                        <img id="img-present" class="img-thumbnail" src="LuckyDiceImages/motobike.jpg">
                    </div>
                </div>
            </div>
        </div>
        <div class="row  text-center form-group"> <!-- Tại row 2.2 thêm một div column rộng 12 đơn vị  -->
            <div class="col-12">
                <button id="btn-dice-history" class="btn btn-info button-width w-25">Dice History</button>
                <button id="btn-voucher-history" class="btn btn-success button-width w-25">Voucher History</button>
                <button id="btn-present-history" class="btn btn-success button-width w-25">Present History</button>
            </div>
        </div>
        <div class="row "> <!-- Tại row 2.3 thêm một div column rộng 12 đơn vị  -->
            <div class="col-12">
                <table id="history-placeholder-table" class="table table-striped table-hover ">
                    <tr>
                        <th>Lượt</th>
                        <th>Dice</th>
                    </tr>
                    <tr>
                        <td>1</td>
                        <td>2</td>
                    </tr>
                    <tr>
                        <td>2</td>
                        <td>6</td>
                    </tr>
                    <tr>
                        <td>3</td>
                        <td>4</td>
                    </tr>
                    <tr>
                        <td>4</td>
                        <td>5</td>
                    </tr>
                    <tr>
                        <td>5</td>
                        <td>4</td>
                    </tr>
                </table>
            </div>
        </div>
    </div>
</body>
<script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gEND_OF_ROW_COL = -1;
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    const gBASE_URL = "http://203.171.20.210:8080/devcamp-lucky-dice/dice/";
    const gUTF8_TEXT_APPLICATION_HEADER = "application/json;charset=UTF-8";



    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    $(document).ready(function () {
        $("#btn-dice").on("click", function () {
            onBtnNemXucXac();
        })

    })

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onBtnNemXucXac() {
        var vDataObj = {
            userName: "",
            firstName: "",
            lastName: "",
        }
        getNemData(vDataObj);
        var vXmlHttp = new XMLHttpRequest();
        goiApiNem(vDataObj, vXmlHttp);
        vXmlHttp.onreadystatechange = function () {
            if (vXmlHttp.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && vXmlHttp.status == gREQUEST_STATUS_OK) {
                displayDice(vXmlHttp);
                displayVoucher(vXmlHttp);
                displayPresent(vXmlHttp);
                console.log(vXmlHttp.responseText)
            }
        }
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    function getNemData(paramNem) {
        paramNem.userName = $("#inp-user-name").val().trim();
        paramNem.firstName = $("#inp-first-name").val().trim();
        paramNem.lastName = $("#inp-last-name").val().trim();
    }
    function validateNemData(paramNem) {
        if (paramNem.userName == "") {
            alert("vui lòng nhập user Name!");
            return false;
        }
        return true;
    }
    // goi api nem
    function goiApiNem(paramNem, paramXmlHttp) {
        var vJsonData = JSON.stringify(paramNem);
        paramXmlHttp.open("POST", gBASE_URL, true);
        paramXmlHttp.setRequestHeader("Content-Type", gUTF8_TEXT_APPLICATION_HEADER);
        paramXmlHttp.send(vJsonData);
    }
    function displayDice(paramXmlHttp) {
        var vDataDiceObj = JSON.parse(paramXmlHttp.responseText);
        console.log("dice: " + vDataDiceObj.dice);
        if (vDataDiceObj.dice == 1) {
            $("#img-dice").attr("src", "LuckyDiceImages/1.png");
            $("#p-notification-dice")
                .html("Chúc bạn may mắn lần sau!")
                .css("color", "orange")
        }
        else if (vDataDiceObj.dice == 2) {
            $("#img-dice").attr("src", "LuckyDiceImages/2.png");
            $("#p-notification-dice")
                .html("Chúc bạn may mắn lần sau!")
                .css("color", "orange")
        }
        else if (vDataDiceObj.dice == 3) {
            $("#img-dice").attr("src", "LuckyDiceImages/3.png");
            $("#p-notification-dice")
                .html("Chúc bạn may mắn lần sau!")
                .css("color", "orange")
        }
        else if (vDataDiceObj.dice == 4) {
            $("#img-dice").attr("src", "LuckyDiceImages/4.png");
            $("#p-notification-dice")
                .html("Chơi tiếp nhé!")
                .css("color", "green")
        }
        else if (vDataDiceObj.dice == 5) {
            $("#img-dice").attr("src", "LuckyDiceImages/5.png");
            $("#p-notification-dice")
                .html("Chơi tiếp nhé!")
                .css("color", "green")
        }
        else if (vDataDiceObj.dice == 6) {
            $("#img-dice").attr("src", "LuckyDiceImages/6.png");
            $("#p-notification-dice")
                .html("Chơi tiếp nhé!")
                .css("color", "green")
        }
    }
    // show voucher
    function displayPresent(paramXmlHttp) {
        var vDataDiceObj = JSON.parse(paramXmlHttp.responseText);
        if (vDataDiceObj.prize == null) {
            $("#img-present").attr("src", "LuckyDiceImages/no-present.jpg");

        }
        else if (vDataDiceObj.prize == "Mũ") {
            $("#img-present").attr("src", "LuckyDiceImages/hat.jpg");
        }
        else if (vDataDiceObj.prize == "Xe máy") {
            $("#img-present").attr("src", "LuckyDiceImages/car.jpg");
        }
        else if (vDataDiceObj.prize == "Bút") {
            $("#img-present").attr("src", "LuckyDiceImages/but.png");
        }
        else if (vDataDiceObj.prize == "Sổ") {
            $("#img-present").attr("src", "LuckyDiceImages/book.jpg");
        }
        else if (vDataDiceObj.prize == "Áo mưa") {
            $("#img-present").attr("src", "LuckyDiceImages/ao-mua.jpg");
        }
        else if (vDataDiceObj.prize == "Xe mô tô") {
            $("#img-present").attr("src", "LuckyDiceImages/motobike.jpg");
        }

    }
    function displayVoucher(paramXmlHttp) {
        var vDataDiceObj = JSON.parse(paramXmlHttp.responseText);
        if (vDataDiceObj.voucher == null) {
            $("#p-voucher-id").html("No ID");
            $("#p-voucher-percent").html("0%");
        }
        else {
            $("#p-voucher-id").html("Id voucher :" + vDataDiceObj.voucher.maVoucher);
            $("#p-voucher-percent").html("Phần trăm giảm giá :" + vDataDiceObj.voucher.phanTramGiamGia + "%");
        }

    }

</script>

</html>